## ros-kinetic-opencv-candidate 0.2.5

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(opencv_candidate)

find_package(catkin REQUIRED)
find_package(libg2o QUIET)
find_package(OpenCV)
find_library(DEPTH_SENSE_LIBRARIES DepthSense /opt/DepthSenseSDK/lib)

if (${DEPTH_SENSE_LIBRARIES} STREQUAL DEPTH_SENSE_LIBRARIES-NOTFOUND)
  set(OPENCV_CREATIVE "")
else()
  set(OPENCV_CREATIVE opencv_creative)
endif()

if (libg2o_FOUND)
  set(EXTRA_DEPENDS libg2o)
  set(EXTRA_LIBRARIES opencv_candidate_reconst3d)
endif()

if(OpenCV_VERSION VERSION_LESS "3.0")
set(RGB_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/src/rgbd/include)
endif()

catkin_package(DEPENDS OpenCV ${EXTRA_DEPENDS}
               INCLUDE_DIRS include ${RGB_INCLUDE_DIRS}
               LIBRARIES opencv_candidate
                         ${OPENCV_CREATIVE}
                         opencv_rgbd
                         ${opencv_candidate_reconst3d}
)

find_package(OpenCV REQUIRED core imgproc highgui calib3d)
message(STATUS "OpenCV version: ${OpenCV_VERSION}")
message(STATUS "OpenCV headers: ${OpenCV_INCLUDE_DIRS}")
include_directories(SYSTEM ${OpenCV_INCLUDE_DIRS})
include_directories(include)

# install the include directory
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/include)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/src/rgbd/include)

install(DIRECTORY ${PROJECT_SOURCE_DIR}/include/opencv_candidate
        DESTINATION include
        COMPONENT main
)

add_subdirectory(src)

=== src/CMakeLists.txt ===
add_subdirectory(opencv_candidate)
add_subdirectory(reconst3d)
if(OpenCV_VERSION VERSION_LESS "3.0")
add_subdirectory(rgbd)
endif()

find_library(DEPTH_SENSE_LIBRARIES DepthSense /opt/DepthSenseSDK/lib)

if (NOT ${DEPTH_SENSE_LIBRARIES} STREQUAL DEPTH_SENSE_LIBRARIES-NOTFOUND)
  add_subdirectory(creative)
endif()

=== src/opencv_candidate/CMakeLists.txt ===
add_library(opencv_candidate datamatrix.cpp
                             feature2d.cpp
)

target_link_libraries(opencv_candidate
  ${OpenCV_LIBS}
  )
set_target_properties(opencv_candidate PROPERTIES COMPILE_FLAGS "-fopenmp" LINK_FLAGS "-fopenmp")

#set_target_properties(opencv_candidate PROPERTIES COMPILE_FLAGS "-msse4.2")

install(TARGETS opencv_candidate
    DESTINATION lib
    )

=== src/reconst3d/CMakeLists.txt ===
find_package(libg2o QUIET)

if (NOT ${libg2o_FOUND})
return()
endif()

find_package(OpenCV REQUIRED)

# Model capture stuff
find_package(PCL REQUIRED COMPONENTS io filters visualization features segmentation surface)
include_directories(SYSTEM ${PCL_INCLUDE_DIRS}
                           /usr/include/suitesparse
)

# Find Eigen3
FIND_PACKAGE(Eigen)
find_package(libg2o)

include_directories(SYSTEM ${EIGEN_INCLUDE_DIRS})

# add reconst3d library
file(GLOB reconst3d_sources "*.cpp")

add_library(opencv_candidate_reconst3d ${reconst3d_sources})
target_link_libraries(opencv_candidate_reconst3d ${catkin_LIBRARIES}
                                                 ${OpenCV_LIBRARIES}
                                                 opencv_rgbd
                                                 opencv_candidate
                                                 ${libg2o_LIBRARIES}
                                                 ${PCL_LIBRARIES}
                                                 cholmod
                                                 cxsparse
)
set_target_properties(opencv_candidate_reconst3d PROPERTIES COMPILE_FLAGS "-fopenmp" LINK_FLAGS "-fopenmp")

# add model capture samples
add_executable(circular_model_capture samples/circular_model_capture.cpp)
target_link_libraries(circular_model_capture ${OpenCV_LIBRARIES}
                                    opencv_rgbd
                                    opencv_candidate_reconst3d
)
set_target_properties(circular_model_capture PROPERTIES COMPILE_FLAGS "-fopenmp" LINK_FLAGS "-fopenmp")

add_executable(arbitrary_model_capture samples/arbitrary_model_capture.cpp)
target_link_libraries(arbitrary_model_capture ${OpenCV_LIBRARIES}
                                    opencv_rgbd
                                    opencv_candidate_reconst3d
)
set_target_properties(arbitrary_model_capture PROPERTIES COMPILE_FLAGS "-fopenmp" LINK_FLAGS "-fopenmp")

add_executable(cylinder_evaluation samples/cylinder_evaluation.cpp)
target_link_libraries(cylinder_evaluation ${OpenCV_LIBRARIES}
                                    opencv_rgbd
                                    opencv_candidate_reconst3d
)
set_target_properties(cylinder_evaluation PROPERTIES COMPILE_FLAGS "-fopenmp" LINK_FLAGS "-fopenmp")

=== debian/changelog ===
ros-kinetic-opencv-candidate (0.2.5-0xenial) xenial; urgency=high

  * fixes for Kinetic
  * do not compile RGBD for OpenCV3 (as it is in there)
  * proper error handling in OpenCV3
    fixes #5 <https://github.com/wg-perception/opencv_candidate/issues/5>
  * Contributors: Vincent Rabaud

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Fri, 22 Apr 2016 22:00:00 -0000

ros-kinetic-opencv-candidate (0.2.4-0xenial) xenial; urgency=high

  * get features2d to compile with OpenCV3
  * do not compile RGBD for OpenCV3 as there should be an opencv_contrib module anyway
  * remove Python bindings of data matrix
  * remove LSH as it is now upstream
  * get datamatrix to compile with OpenCV3
  * Updating namespaces
  * Contributors: Vincent Rabaud, edgarriba

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Sat, 28 Mar 2015 23:00:00 -0000

ros-kinetic-opencv-candidate (0.2.3-0xenial) xenial; urgency=high

  * no need for CMake hacks (plus, cholmod is not needed anymore)
  * Contributors: Vincent Rabaud

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Sat, 19 Jul 2014 22:00:00 -0000

ros-kinetic-opencv-candidate (0.2.2-0xenial) xenial; urgency=high

  * do not build reconst3d as it is not used anywhere
    It's also a way to remove a package that depends on g2o for less maintenance
  * update url and maintainer's email address
  * add basic docs
  * compile under trusty
  * Contributors: Vincent Rabaud

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Fri, 18 Jul 2014 22:00:00 -0000

ros-kinetic-opencv-candidate (0.2.1-0xenial) xenial; urgency=high

  * get distro agnostic OpenCv2 dependency
  * Contributors: Vincent Rabaud

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Sat, 12 Apr 2014 22:00:00 -0000

ros-kinetic-opencv-candidate (0.2.0-0xenial) xenial; urgency=high

  * disable tests as the Ubuntu version of OpenCV has a bug with TS for now (cvconfig.h not present)
  * drop Fuerte support
  * Contributors: Vincent Rabaud

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Sat, 12 Apr 2014 22:00:00 -0000

ros-kinetic-opencv-candidate (0.1.9-0xenial) xenial; urgency=high

  * fix dependencies with PCL

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Wed, 28 Aug 2013 21:14:21 +0200

=== debian/control ===
Source: ros-kinetic-opencv-candidate
Section: misc
Priority: extra
Maintainer: Vincent Rabaud <vincent.rabaud@gmail.com>
Build-Depends: debhelper (>= 9.0.0), ros-kinetic-catkin, ros-kinetic-cv-bridge
Homepage: https://github.com/wg-perception/opencv_candidate
Standards-Version: 3.9.2

Package: ros-kinetic-opencv-candidate
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-kinetic-cv-bridge
Description: Experimental OpenCV functions

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DH_OPTIONS=-v --buildsystem=cmake
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/kinetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh  $@

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/kinetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/kinetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-kinetic-opencv-candidate//opt/ros/kinetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_install
